diff --git a/libr/main/rafind2.c b/libr/main/rafind2.c
index 176a66891f9a4..6c5cab9dfeeff 100644
--- a/libr/main/rafind2.c
+++ b/libr/main/rafind2.c
@@ -48,6 +48,7 @@ static void rafind_options_init(RafindOptions *ro) {
 	ro->mode = R_SEARCH_STRING;
 	ro->bsize = 4096;
 	ro->to = UT64_MAX;
+	ro->color = true;
 	ro->keywords = r_list_newf (NULL);
 	ro->pj = NULL;
 }
@@ -66,7 +67,7 @@ static int hit(RSearchKeyword *kw, void *user, ut64 addr) {
 		eprintf ("Invalid delta %d from 0x%08"PFMT64x"\n", delta, addr);
 		return 0;
 	}
-	if (delta < 0) {
+	if (delta != 0) {
 		// rollback the buffer and reset the delta
 		buf = calloc (1, ro->bsize * 2);
 		r_io_pread_at (ro->io, addr, buf, ro->bsize * 2);
@@ -145,7 +146,8 @@ static int hit(RSearchKeyword *kw, void *user, ut64 addr) {
 		} else {
 			printf ("0x%"PFMT64x"\n", addr);
 			if (ro->pr) {
-				r_print_hexdump (ro->pr, addr, (ut8*)buf + delta, 78, 16, 1, 1);
+				int bs = R_MIN (ro->bsize, 64);
+				r_print_hexdump (ro->pr, addr, (ut8*)buf + delta, bs, 16, 1, 1);
 				r_cons_flush ();
 			}
 		}
@@ -164,7 +166,7 @@ static int show_help(const char *argv0, int line) {
 	printf (
 	" -a [align] only accept aligned hits\n"
 	" -b [size]  set block size\n"
-	" -c         enable colourful output (mainly for for -X)\n"
+	" -c         disable colourful output (mainly for for -X)\n"
 	" -e [regex] search for regex matches (can be used multiple times)\n"
 	" -f [from]  start searching from address 'from'\n"
 	" -F [file]  read the contents of the file and use it as keyword\n"
@@ -385,7 +387,7 @@ R_API int r_main_rafind2(int argc, const char **argv) {
 			ro.align = r_num_math (NULL, opt.arg);
 			break;
 		case 'c':
-			ro.color = true;
+			ro.color = false;
 			break;
 		case 'r':
 			ro.rad = true;
diff --git a/test/db/tools/rafind2 b/test/db/tools/rafind2
index b896f82155949..9d265995dc140 100644
--- a/test/db/tools/rafind2
+++ b/test/db/tools/rafind2
@@ -1,6 +1,6 @@
-NAME=rafind2 -s 1234 -X -b 0x100 -c
+NAME=rafind2 -s 1234 -X -b 0x100
 FILE=--
-CMDS=!rafind2 -s 1234 -X -b 0x100 -c bins/other/search.bin
+CMDS=!rafind2 -s 1234 -X -b 0x100 bins/other/search.bin
 EXPECT=<<EOF
 0xfe
 [35m- offset -   0 1  2 3  4 5  6 7  8 9  A B  C D  E F  0123456789ABCDEF
@@ -8,12 +8,22 @@ EXPECT=<<EOF
 [32m0x0000010e[0m  [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m  [32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m
 [32m0x0000011e[0m  [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m  [32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m
 [32m0x0000012e[0m  [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m  [32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m
-[32m0x0000013e[0m  [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m [32m00[0m[32m00[0m       [32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m[32m.[0m
 EOF
 RUN
+
 NAME=rafind2 -s 1234 -X -b 0x100
 FILE=--
-CMDS=!rafind2 -s 1234 -X -b 0x100 bins/other/search.bin
+CMDS=!rafind2 -c -s 1234 -X -b 8 bins/other/search.bin
+EXPECT=<<EOF
+0xfe
+- offset -   0 1  2 3  4 5  6 7  8 9  A B  C D  E F  0123456789ABCDEF
+0x000000fe  3132 3334 0000 0000                      1234....
+EOF
+RUN
+
+NAME=rafind2 -s 1234 -X -b 0x100
+FILE=--
+CMDS=!rafind2 -c -s 1234 -X -b 0x100 bins/other/search.bin
 EXPECT=<<EOF
 0xfe
 - offset -   0 1  2 3  4 5  6 7  8 9  A B  C D  E F  0123456789ABCDEF
@@ -21,13 +31,12 @@ EXPECT=<<EOF
 0x0000010e  0000 0000 0000 0000 0000 0000 0000 0000  ................
 0x0000011e  0000 0000 0000 0000 0000 0000 0000 0000  ................
 0x0000012e  0000 0000 0000 0000 0000 0000 0000 0000  ................
-0x0000013e  0000 0000 0000 0000 0000 0000 0000       ..............
 EOF
 RUN
 
 NAME=rafind2 -s 1234 -X
 FILE=--
-CMDS=!rafind2 -q -s 1234 -X bins/other/search.bin
+CMDS=!rafind2 -cq -s 1234 -X bins/other/search.bin
 EXPECT=<<EOF
 0xfe
 - offset -   0 1  2 3  4 5  6 7  8 9  A B  C D  E F  0123456789ABCDEF
@@ -35,13 +44,12 @@ EXPECT=<<EOF
 0x0000010e  0000 0000 0000 0000 0000 0000 0000 0000  ................
 0x0000011e  0000 0000 0000 0000 0000 0000 0000 0000  ................
 0x0000012e  0000 0000 0000 0000 0000 0000 0000 0000  ................
-0x0000013e  0000 0000 0000 0000 0000 0000 0000       ..............
 EOF
 RUN
 
 NAME=rafind2 -X -s
 FILE=-
-CMDS=!rafind2 -X -s 250382 bins/elf/ioli/crackme0x00
+CMDS=!rafind2 -cX -s 250382 bins/elf/ioli/crackme0x00
 EXPECT=<<EOF
 0x58f
 - offset -   0 1  2 3  4 5  6 7  8 9  A B  C D  E F  0123456789ABCDEF
@@ -49,7 +57,6 @@ EXPECT=<<EOF
 0x0000059f  6173 7377 6f72 6421 0a00 5061 7373 776f  assword!..Passwo
 0x000005af  7264 204f 4b20 3a29 0a00 0000 0000 0000  rd OK :)........
 0x000005bf  0000 0000 0000 0000 0000 0000 0000 0000  ................
-0x000005cf  0000 0000 0000 0000 0000 0000 0000       ..............
 EOF
 RUN
 
